/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-06 * new file - Rolf
*/

#include <stdlib.h>
#include <memory.h>
#include "common.h"
#include "BitStream.h"

BitStream::BitStream(ubyte* data,uint size):
bit_offset(0),
data(data)
{
	max_byte=data+(size-4);
}

BitSink::BitSink(ubyte* &storage_pointer):
byte_offset(0),bit_offset(0)
{
	allocated_bytes=65536;
 	data=(ubyte*)calloc(allocated_bytes,1);
 	client_data=&storage_pointer;
}

void
BitSink::insert(uint symbol,uint sym_size)
{
	if ((byte_offset+5)>allocated_bytes)
	{
		allocated_bytes*=2;
		data=(ubyte*)realloc(data,allocated_bytes);
		*client_data=data;
		memset(data+(allocated_bytes>>1),0,allocated_bytes>>1);
	}
	*((uint*)(data+byte_offset))|=symbol<<bit_offset;
	bit_offset+=sym_size;
	byte_offset+=bit_offset>>3;
	bit_offset&=7;
}

uint
BitSink::finalize()
{
	uint ret=byte_offset+4;
	data=(ubyte*)realloc(data,ret);
	*client_data=data;
	return(ret);
}


