/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-05 * added proper LGPL notice, started changelog - Rolf

*/

#include <deque>					//needed for Generator.h
#include <vector>					//needed for ContextFactory.h
#include "common.h"
#include "Section.h"				//needed for MaskedImage.h
#include "Span.h"					//needed for MaskedImage.h
#include "downfilter.ah"			//needed for RgbImage.h
#include "x86_timer.ah"				//needed for RgbImage.h
#include "Timing.h"					//needed for RgbImage.h
#include "MaskedImage.h"			//needed for Fractal.h
#include "ExtremeFloat.h"			//needed for Fractal.h
#include "Fractal.h"				//needed for Context.h
#include "Generator.h"				//needed for Context.h
#include "RgbImage.h"				//needed for Context.h
#include "brot_core_interface.h"	//needed for Context.h
#include "HistEntry.h"				//needed for Context.h
#include "Context.h"				//needed for ContextFactory.h

#include "ContextFactory.h"

ContextFactory::ContextFactory()
{
}

ContextFactory::~ContextFactory()
{
	for (uint i=0;i<child.size();++i)
	{
		SAFE_DELETE(child[i]);
	}
	child.clear();
}

Context*
ContextFactory::create_context(Fractal* f,uint megs)
{
	Context* c=new Context(f,megs);
	child.push_back(c);
	return(c);
}

bool
ContextFactory::is_context(Context* c)
{
	if (c==NULL) return(false);

	for (uint i=0;i<child.size();++i)
	{
		if (child[i]==c) return(true);
	}
	return(false);
}

void
ContextFactory::destroy(Context* c)
{
	for (uint i=0;i<child.size();++i)
	{
		if (child[i]==c)
		{
			SAFE_DELETE(child[i]);
			Context* gap_filler=child.back();
			child.pop_back();
			if (gap_filler==c) return;
			child[i]=gap_filler;
			return;
		}
	}
}

