/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-06 * added stride for more versatility - Rolf
03/Mar-05 * added proper LGPL notice - Rolf
03/Mar-03 * new file - Rolf

*/


//a two-dimensional loop counter ... or something like that
class
Counter2D
{
public:
    Counter2D(int width,int height):w(width),stride(width),h(height),x(0),y(0),acc(0) {};
    Counter2D(int width,int height,int stride):w(width),stride(stride),h(height),x(0),y(0),acc(0) {};
    
    void operator ++() {if (++x==w) {++y; x=0; acc+=stride;} }
    bool through()const {return(y==h);}
    int linear()const {return(acc+x);}  //magically return y*stride+x
    void set(int x,int y) {this->x=x; this->y=y; acc=w*y; }
    
    int x,y;
private:
    int w,h;
    int acc;
	int stride;
};

