/*
this is part of brot_core.dll, a fractal generation library
Copyright (C) 2003 Rolf Neuberger

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
changes:
03/Mar-05 * added save member function and FILE* constructor - Rolf
03/Mar-05 * new file, spun off from Context.h - Rolf
*/

class
HistEntry
{
public:
	HistEntry(Fractal* f,int w,int h,int aa,int gtype):
		fractal(f),width(w),height(h),aa_strength(aa),
  			generator_type(gtype),
			generator(NULL),finished(false),
			cleverness(0.0f),progress(0.0f),
            total_time(0.0f),hibernated(false) {};

	HistEntry():fractal(NULL),width(0),height(0),aa_strength(0),
 			generator_type(BC_CONTOUR_TRACING),
			generator(NULL),finished(false),
			cleverness(0.0f),progress(0.0f),
            total_time(0.0f),hibernated(false) {};

	HistEntry(FILE* input);

	bool save(FILE* of,bool everything);


    void reset_stats() { finished=false;
        progress=0.0f; cleverness=0.0f; total_time=0.0f; }



public:
	Fractal* fractal;
	Generator* generator;

	int width;
	int height;
	int aa_strength;
	int generator_type;
	float cleverness;
	float progress;
	float total_time;
	bool finished;
	bool hibernated;
};
